
#include "grid.bas"

dim shared as integer values(ONE to SEVEN)

type TEngine
  as integer flag
  declare function Winning(g as TGrid, p as piece, x as integer) as boolean
  declare function Losing(g as TGrid, p as piece, x as integer) as boolean
  declare function Value(g as TGrid, p as piece, x as integer) as integer
  declare function CenterBonus(g as TGrid, x as integer) as integer
  declare function Move(g as TGrid, p as piece) as integer
end type

function TEngine.Winning(g as TGrid, p as piece, x as integer) as boolean
  dim as boolean b(ONE to SEVEN), result = true
  dim as TGrid g1, g2
  dim as integer i, j
  g1.Empty
  g2.Empty
  if g.array(x, SIX) <> nothing then return false
  for i = ONE to SEVEN
    b(i) = false
    g1.Copy(g.array())
    g1.Insert(p, x)
    g1.Insert(black * p, i)
    if (g1.GridPoints(black * p) < FOUR) then
      for j = ONE to SEVEN
        g2.Copy(g1.array())
        g2.Insert(p, j)
        if g2.GridPoints(p) >= FOUR then
          b(i) = true
          exit for
        end if
      next j
    end if
  next i
  for i = ONE to SEVEN
    result = result and b(i)
  next i
  function = result
end function

function TEngine.Losing(g as TGrid, p as piece, x as integer) as boolean
  dim as boolean b(ONE to SEVEN), result = false
  dim g1 as TGrid
  dim as integer i
  g1.Empty
  for i = ONE to SEVEN
    b(i) = false
    g1.Copy(g.array())
    g1.Insert(p, x)
    b(i) = Winning(g1, black * p, i)
  next i
  for i = ONE to SEVEN
    result = result or b(i)
  next i
  function = result
end function

function TEngine.Value(g as TGrid, p as piece, x as integer) as integer
  dim as TGrid g1, g2
  dim as integer i, j, k, l, result, a(ONE to SEVEN), b(ONE to SEVEN)
  g1.Empty
  g2.Empty
  g1.Copy(g.array())
  if g1.Insert(p, x) then
    result = 0
    for i = ONE to SEVEN
      g1.Copy(g.array())
      g1.Insert(p, x)
      g1.Insert(black * p, i)
      a(i) = g1.GridPoints(black * p)
    next i
    i = Maximum(a())
    j = Number(a(), i)
    result -= 10000 * i + 1000 * j
    for i = ONE to SEVEN
      g1.Copy(g.array())
      g1.Insert(p, x)
      g1.Insert(black * p, i)
      for j = ONE to SEVEN
        g2.Copy(g1.array())
        g2.Insert(p, j)
        b(j) = g2.GridPoints(p)
      next j
      a(i) = Maximum(b())
    next i
    i = Minimum(a())
    j = Number(a(), i)
    result += 100 * i + 10 * j
    result += CenterBonus(g, x)
  else
    result = MIN_INT
  end if
  function = result
end function

function TEngine.CenterBonus(g as TGrid, x as integer) as integer
  dim as integer y = SIX, result = 0
  if g.array(x, y) = nothing then
    while (y > ONE) andalso (g.array(x, y - 1) = nothing)
      y -= 1
    wend
    result = 3 - abs(4 - x) + 2 - fix(abs(3.5 - y))
  end if
  function = result
end function

function TEngine.Move(g as TGrid, p as piece) as integer
  dim g1 as TGrid
  dim as integer i, result, a(ONE to SEVEN)
  g1.Empty
  for i = ONE to SEVEN
    g1.Copy(g.array())
    if g1.Insert(p, i) andalso (g1.GridPoints(p) >= FOUR) then return i
  next i
  for i = ONE to SEVEN
    a(i) = Value(g, p, i)
    values(i) = a(i)
  next i
  i = Maximum(a())
  result = Index(a(), i)
  function = result
end function
